"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.dispatchEventsToZRender = dispatchEventsToZRender;
var _zrender = require("zrender/lib/zrender");
const noop = () => {};
function dispatchEventsToZRender(zrenderId, types, nativeEvent) {
  let eventArgs = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {
    zrX: nativeEvent.locationX || nativeEvent.x,
    zrY: nativeEvent.locationY || nativeEvent.y
  };
  if (zrenderId) {
    var handler = (0, _zrender.getInstance)(zrenderId).handler;
    types.forEach(function (type) {
      handler.dispatch(type, {
        preventDefault: noop,
        stopImmediatePropagation: noop,
        stopPropagation: noop,
        ...eventArgs
      });
    });
  }
}
//# sourceMappingURL=events.js.map