"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.throttle = throttle;
function throttle(func, wait) {
  let lastExecution = 0;
  return function () {
    const now = Date.now();
    if (now - lastExecution >= wait) {
      lastExecution = now;
      func(...arguments);
    }
  };
}
//# sourceMappingURL=throttle.js.map